Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsed.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 12537)
@@ -2,5 +2,8 @@
    !!======================================================================
    !!                         ***  MODULE p4sed  ***
-   !! TOP :   PISCES Compute loss of organic matter in the sediments
+   !! TOP :   PISCES Compute loss of biogenic matter in the sediments
+   !!                Compute gain/loss of tracers from dust, rivers and 
+   !!                sediments 
+   !!                This module is used both by PISCES and PISCES-QUOTA
    !!======================================================================
    !! History :   1.0  !  2004-03 (O. Aumont) Original code
@@ -8,7 +11,9 @@
    !!             3.4  !  2011-06 (C. Ethe) USE of fldread
    !!             3.5  !  2012-07 (O. Aumont) improvment of river input of nutrients 
-   !!----------------------------------------------------------------------
+   !!-----------------------------------------------------------------------
    !!   p4z_sed        :  Compute loss of organic matter in the sediments
-   !!----------------------------------------------------------------------
+   !!                  :  Compute gain/loss of tracers from dust, rivers and 
+   !!                     sediments 
+   !!-----------------------------------------------------------------------
    USE oce_trc         !  shared variables between ocean and passive tracers
    USE trc             !  passive tracers common variables 
@@ -43,7 +48,10 @@
       !!                     ***  ROUTINE p4z_sed  ***
       !!
-      !! ** Purpose :   Compute loss of organic matter in the sediments. This
-      !!              is by no way a sediment model. The loss is simply 
-      !!              computed to balance the inout from rivers and dust
+      !! ** Purpose :   Compute loss of biogenic matter in the sediments. This
+      !!              is by no way a real sediment model. The loss is simply 
+      !!              computed from metamodels.
+      !!              Loss/gain of tracers are also computed here for 
+      !!              dust, rivers, sediments and hydrothermal vents (Fe) 
+      !!              N2 fixation is modeled using an implicit approach
       !!
       !! ** Method  : - ???
@@ -93,5 +101,8 @@
       zsedc   (:,:) = 0.e0
 
-      ! Iron input/uptake due to sea ice : Crude parameterization based on Lancelot et al.
+      ! Iron input/uptake due to sea ice : Crude parameterization based on 
+      ! Lancelot et al. Iron concentration in sea-ice is constant and set 
+      ! in the namelist_pisces (icefeinput). ln_ironice is forced to false
+      ! when nn_ice_tr = 1
       ! ----------------------------------------------------
       IF( ln_ironice ) THEN  
@@ -99,4 +110,5 @@
          ALLOCATE( zironice(jpi,jpj) )
          !                                              
+         ! Compute the iron flux between sea ice and sea water
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -106,5 +118,5 @@
             END DO
          END DO
-         !
+         ! Update of the TRA array
          tra(:,:,1,jpfer) = tra(:,:,1,jpfer) + zironice(:,:) 
          ! 
@@ -121,5 +133,9 @@
          !                                              
          ALLOCATE( zsidep(jpi,jpj), zpdep(jpi,jpj,jpk), zirondep(jpi,jpj,jpk) )
-         !                                              ! Iron and Si deposition at the surface
+         ! Iron, P and Si deposition at the surface
+         ! Iron flux at the surface due to dust deposition. Solubility can be 
+         ! be variable if ln_solub is set to true. In that case, solubility 
+         ! has to be provided in the specific input file (read in p4zsbc)
+         ! ------------------------------------------------------------------
          IF( ln_solub ) THEN
             zirondep(:,:,1) = solub(:,:) * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 55.85 + 3.e-10 * r1_ryyss 
@@ -127,14 +143,23 @@
             zirondep(:,:,1) = dustsolub  * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 55.85 + 3.e-10 * r1_ryyss 
          ENDIF
+         ! Si and P flux at the surface due to dust deposition. The content 
+         ! and the solubility are hard coded
+         ! ----------------------------------------------------------------
          zsidep(:,:)   = 8.8 * 0.075 * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 28.1 
          zpdep (:,:,1) = 0.1 * 0.021 * dust(:,:) * mfrac * rfact2 / e3t_n(:,:,1) / 31. / po4r 
-         !                                              ! Iron solubilization of particles in the water column
-         !                                              ! dust in kg/m2/s ---> 1/55.85 to put in mol/Fe ;  wdust in m/j
-         zwdust = 0.03 * rday / ( wdust * 55.85 ) / ( 270. * rday )
+         ! Iron solubilization of particles in the water column
+         ! dust in kg/m2/s ---> 1/55.85 to put in mol/Fe ;  wdust in m/d
+         ! Dust are supposed to sink at wdust sinking speed. 3% of the iron 
+         ! in dust is hypothesized to be soluble at a dissolution rate set to 
+         ! 1/(250 days). The vertical distribution of iron in dust is computed 
+         ! from a steady state assumption. Parameters are very uncertain and 
+         ! are estimated from the literature quoted in Raiswell et al. (2011) 
+         ! ------------------------------------------------------------------- 
+         zwdust = 0.03 * rday / ( wdust * 55.85 ) / ( 250. * rday )
          DO jk = 2, jpkm1
-            zirondep(:,:,jk) = dust(:,:) * mfrac * zwdust * rfact2 * EXP( -gdept_n(:,:,jk) / 540. )
+            zirondep(:,:,jk) = dust(:,:) * mfrac * zwdust * rfact2 * EXP( -gdept_n(:,:,jk) / (250. * wdust) )
             zpdep   (:,:,jk) = zirondep(:,:,jk) * 0.023
          END DO
-         !                                              ! Iron solubilization of particles in the water column
+         ! Solubilization of particles in the water column (Si, P, Fe)
          tra(:,:,1,jpsil) = tra(:,:,1,jpsil) + zsidep  (:,:)
          DO jk = 1, jpkm1
@@ -156,5 +181,5 @@
      
       ! Add the external input of nutrients from river
-      ! ----------------------------------------------------------
+      ! ----------------------------------------------
       IF( ln_river ) THEN
          DO jj = 1, jpj
@@ -171,4 +196,8 @@
             ENDDO
          ENDDO
+         ! When prognostic ligands are activated, ligands are supplied 
+         ! to the ocean by rivers. We assume that the amount of ligands
+         ! is equal to that of iron (iron is completely complexed)
+         ! ------------------------------------------------------------
          IF (ln_ligand) THEN
             DO jj = 1, jpj
@@ -180,4 +209,5 @@
             ENDDO
          ENDIF
+         ! PISCES-QUOTA part
          IF( ln_p5z ) THEN
             DO jj = 1, jpj
@@ -200,5 +230,6 @@
 
       ! Add the external input of iron from hydrothermal vents
-      ! ------------------------------------------------------
+      ! Please refer to Tagliabue et al. (2010) for more information
+      ! ------------------------------------------------------------
       IF( ln_hydrofe ) THEN
             tra(:,:,:,jpfer) = tra(:,:,:,jpfer) + hydrofe(:,:,:) * rfact2
@@ -211,5 +242,7 @@
       ENDIF
 
-      ! OA: Warning, the following part is necessary to avoid CFL problems above the sediments
+      ! OA: Warning, the following part is necessary to avoid CFL problems 
+      ! above the sediments. Vertical sinking speed is limited using the 
+      ! typical CFL criterion
       ! --------------------------------------------------------------------
       DO jj = 1, jpj
@@ -222,4 +255,5 @@
       END DO
       !
+      ! No sediment module activated
       IF( .NOT.lk_sed ) THEN
 !
@@ -233,6 +267,8 @@
          ENDIF
 
-         ! Computation of the sediment denitrification proportion: The metamodel from midlleburg (2006) is being used
-         ! Computation of the fraction of organic matter that is permanently buried from Dunne's model
+         ! Computation of the sediment denitrification proportion: The metamodel 
+         ! from Middleburg (2006) is used
+         ! Computation of the fraction of organic matter that is permanently 
+         ! buried from Dunne's model (2007)
          ! -------------------------------------------------------
          DO jj = 1, jpj
@@ -259,9 +295,11 @@
       ENDIF
 
-      ! This loss is scaled at each bottom grid cell for equilibrating the total budget of silica in the ocean.
-      ! Thus, the amount of silica lost in the sediments equal the supply at the surface (dust+rivers)
-      ! ------------------------------------------------------
+      ! Fraction of dSi that is remineralized in the sediments. This is 
+      ! set so that the burial in sediments equals the total input of Si
+      ! by rivers and dust (sedsilfrac)
+      ! ----------------------------------------------------------------
       IF( .NOT.lk_sed )  zrivsil = 1._wp - sedsilfrac
 
+      ! Loss of bSi and CaCO3 to the sediments
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -278,4 +316,9 @@
       !
       IF( .NOT.lk_sed ) THEN
+         ! Dissolution of CaCO3 and bSi in the sediments. This is 
+         ! instantaneous since here sediments are not explicitly 
+         ! modeled. The amount of CaCO3 that dissolves in the sediments
+         ! is computed using a metamodel constructed from Archer (1996)
+         ! ------------------------------------------------------------
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -298,4 +341,5 @@
       ENDIF
       !
+      ! Loss of particulate organic carbon and Fe to the sediments
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -311,4 +355,5 @@
       END DO
       !
+      ! Loss of particulate organic N and P to the sediments (p5z)
       IF( ln_p5z ) THEN
          DO jj = 1, jpj
@@ -327,6 +372,9 @@
 
       IF( .NOT.lk_sed ) THEN
+         ! Degradation of organic matter in the sediments. The metamodel of 
+         ! Middleburg (2006) is used here to mimic the diagenetic reactions. 
          ! The 0.5 factor in zpdenit is to avoid negative NO3 concentration after
          ! denitrification in the sediments. Not very clever, but simpliest option.
+         ! ------------------------------------------------------------------------
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -360,19 +408,26 @@
 
 
-      ! Nitrogen fixation process
-      ! Small source iron from particulate inorganic iron
-      !-----------------------------------
+      ! Nitrogen fixation process : light limitation of diazotrophy
+      ! Small source of iron from particulate inorganic iron (photochemistry)
+      !----------------------------------------------------------------------
       DO jk = 1, jpkm1
          zlight (:,:,jk) =  ( 1.- EXP( -etot_ndcy(:,:,jk) / diazolight ) ) * ( 1. - fr_i(:,:) ) 
          zsoufer(:,:,jk) = zlight(:,:,jk) * 2E-11 / ( 2E-11 + biron(:,:,jk) )
       ENDDO
+
+      ! Diazotrophy (nitrogen fixation) is modeled according to an empirical
+      ! formulation. This is described in Aumont et al. (2015). Limitation 
+      ! by P and Fe is computed. Inhibition by high N concentrations is imposed.
+      ! Diazotrophy sensitivity to temperature is parameterized as in 
+      ! Ye et al. (2012)  
+      ! ------------------------------------------------------------------------
       IF( ln_p4z ) THEN
+         ! PISCES part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  !                      ! Potential nitrogen fixation dependant on temperature and iron
+                  ! Potential nitrogen fixation dependant on temperature and iron
                   ztemp = tsn(ji,jj,jk,jp_tem)
                   zmudia = MAX( 0.,-0.001096*ztemp**2 + 0.057*ztemp -0.637 ) * 7.625
-                  !       Potential nitrogen fixation dependant on temperature and iron
                   xdianh4 = trb(ji,jj,jk,jpnh4) / ( concnnh4 + trb(ji,jj,jk,jpnh4) )
                   xdiano3 = trb(ji,jj,jk,jpno3) / ( concnno3 + trb(ji,jj,jk,jpno3) ) * (1. - xdianh4)
@@ -388,11 +443,11 @@
          END DO
       ELSE       ! p5z
+         ! PISCES-QUOTA part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  !                      ! Potential nitrogen fixation dependant on temperature and iron
+                  ! Potential nitrogen fixation dependant on temperature and iron
                   ztemp = tsn(ji,jj,jk,jp_tem)
                   zmudia = MAX( 0.,-0.001096*ztemp**2 + 0.057*ztemp -0.637 ) * 7.625
-                  !       Potential nitrogen fixation dependant on temperature and iron
                   xdianh4 = trb(ji,jj,jk,jpnh4) / ( concnnh4 + trb(ji,jj,jk,jpnh4) )
                   xdiano3 = trb(ji,jj,jk,jpno3) / ( concnno3 + trb(ji,jj,jk,jpno3) ) * (1. - xdianh4)
@@ -410,7 +465,8 @@
       ENDIF
 
-      ! Nitrogen change due to nitrogen fixation
-      ! ----------------------------------------
+      ! Update of the TRA arrays due to nitrogen fixation
+      ! -------------------------------------------------
       IF( ln_p4z ) THEN
+         ! PISCES part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
@@ -428,10 +484,9 @@
                   tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + 30E-6 * zfact * 1.0 / 3.0 * 1.0 / 3.0
                   tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + 0.002 * 4E-10 * zsoufer(ji,jj,jk) * rfact2 / rday
-                  tra(ji,jj,jk,jppo4) = tra(ji,jj,jk,jppo4) + concdnh4 / ( concdnh4 + trb(ji,jj,jk,jppo4) ) &
-                  &                     * 0.001 * trb(ji,jj,jk,jpdoc) * xstep
               END DO
             END DO 
          END DO
       ELSE    ! p5z
+         ! PISCES-QUOTA part
          DO jk = 1, jpkm1
             DO jj = 1, jpj
@@ -475,8 +530,8 @@
                CALL iom_put( "INTNFIX" , zwork ) 
             ENDIF
-            IF( iom_use("SedCal" ) ) CALL iom_put( "SedCal", zsedcal(:,:) * zfact )
-            IF( iom_use("SedSi" ) )  CALL iom_put( "SedSi",  zsedsi (:,:) * zfact )
-            IF( iom_use("SedC" ) )   CALL iom_put( "SedC",   zsedc  (:,:) * zfact )
-            IF( iom_use("Sdenit" ) ) CALL iom_put( "Sdenit", sdenit (:,:) * zfact * rno3 )
+            IF( iom_use("SedCal" ) ) CALL iom_put( "SedCal", zsedcal(:,:) * zfact ) ! Permanent burial of CaCO3 in sediments
+            IF( iom_use("SedSi" ) )  CALL iom_put( "SedSi",  zsedsi (:,:) * zfact ) ! Permanent burial of bSi in sediments
+            IF( iom_use("SedC" ) )   CALL iom_put( "SedC",   zsedc  (:,:) * zfact ) ! Permanent burial of OC in sediments
+            IF( iom_use("Sdenit" ) ) CALL iom_put( "Sdenit", sdenit (:,:) * zfact * rno3 ) ! Denitrification in the sediments
          ENDIF
       ENDIF
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsink.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 12536)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 12537)
@@ -2,5 +2,7 @@
    !!======================================================================
    !!                         ***  MODULE p4zsink  ***
-   !! TOP :  PISCES  vertical flux of particulate matter due to gravitational sinking
+   !! TOP :  PISCES  vertical flux of particulate matter due to 
+   !!        gravitational sinking
+   !!        This module is the same for both PISCES and PISCES-QUOTA
    !!======================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -8,4 +10,6 @@
    !!             3.4  !  2011-06  (O. Aumont, C. Ethe) Change aggregation formula
    !!             3.5  !  2012-07  (O. Aumont) Introduce potential time-splitting
+   !!             4.0  !  2019     (O. Aumont) an external subroutine is called
+   !!                                          to compute the impact of sinking
    !!----------------------------------------------------------------------
    !!   p4z_sink       :  Compute vertical flux of particulate matter due to gravitational sinking
@@ -25,11 +29,11 @@
 
    PUBLIC   p4z_sink         ! called in p4zbio.F90
-   PUBLIC   p4z_sink_init    ! called in trcsms_pisces.F90
-   PUBLIC   p4z_sink_alloc
+   PUBLIC   p4z_sink_init    ! called in trcini_pisces.F90
+   PUBLIC   p4z_sink_alloc   ! called in trcini_pisces.F90
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinking, sinking2  !: POC sinking fluxes 
    !                                                          !  (different meanings depending on the parameterization)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkingn, sinking2n  !: POC sinking fluxes 
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkingp, sinking2p  !: POC sinking fluxes 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkingn, sinking2n  !: PON sinking fluxes 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkingp, sinking2p  !: POP sinking fluxes 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkcal, sinksil   !: CaCO3 and BSi sinking fluxes
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   sinkfer            !: Small BFe sinking fluxes
@@ -45,8 +49,4 @@
 CONTAINS
 
-   !!----------------------------------------------------------------------
-   !!   'standard sinking parameterisation'                  ???
-   !!----------------------------------------------------------------------
-
    SUBROUTINE p4z_sink ( kt, knt )
       !!---------------------------------------------------------------------
@@ -54,7 +54,10 @@
       !!
       !! ** Purpose :   Compute vertical flux of particulate matter due to 
-      !!                gravitational sinking
-      !!
-      !! ** Method  : - ???
+      !!                gravitational sinking. 
+      !!
+      !! ** Method  : - An external advection subroutine is called to compute
+      !!                the impact of sinking on the particles. The tracers
+      !!                concentrations are updated in this subroutine which
+      !!                is mandatory to deal with negative concentrations
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) :: kt, knt
@@ -75,8 +78,11 @@
       consgoc(:,:,:) = 0.
 
-      !
-      !    Sinking speeds of detritus is increased with depth as shown
-      !    by data and from the coagulation theory
-      !    -----------------------------------------------------------
+      ! Sinking speeds of big detritus is increased with depth as shown
+      ! by data and from the coagulation theory. This is controled by
+      ! wsbio2max and wsbio2scale. If wsbio2max is set to wsbio2, then
+      ! sinking speed is constant with depth.
+      ! CaCO3 and bSi are supposed to sink at the big particles speed 
+      ! due to their high density
+      ! ---------------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -89,10 +95,9 @@
       END DO
 
-      ! limit the values of the sinking speeds to avoid numerical instabilities  
+      ! Sinking speed of the small particles is constant
       wsbio3(:,:,:) = wsbio
 
-      !
-      !  Initializa to zero all the sinking arrays 
-      !   -----------------------------------------
+      ! Initialize to zero all the sinking arrays 
+      ! -----------------------------------------
       sinking (:,:,:) = 0.e0
       sinking2(:,:,:) = 0.e0
@@ -102,6 +107,6 @@
       sinkfer2(:,:,:) = 0.e0
 
-      !   Compute the sedimentation term using p4zsink2 for all the sinking particles
-      !   -----------------------------------------------------
+      ! Compute the sedimentation term using trc_sink for all the sinking particles
+      ! ---------------------------------------------------------------------------
       CALL trc_sink( kt, wsbio3, sinking , jppoc, rfact2 )
       CALL trc_sink( kt, wsbio3, sinkfer , jpsfe, rfact2 )
@@ -111,4 +116,5 @@
       CALL trc_sink( kt, wsbio4, sinkcal , jpcal, rfact2 )
 
+      ! PISCES-QUOTA part
       IF( ln_p5z ) THEN
          sinkingn (:,:,:) = 0.e0
@@ -117,6 +123,6 @@
          sinking2p(:,:,:) = 0.e0
 
-         !   Compute the sedimentation term using p4zsink2 for all the sinking particles
-         !   -----------------------------------------------------
+         ! Compute the sedimentation term using trc_sink for all the sinking particles
+         ! ---------------------------------------------------------------------------
          CALL trc_sink( kt, wsbio3, sinkingn , jppon, rfact2 )
          CALL trc_sink( kt, wsbio3, sinkingp , jppop, rfact2 )
@@ -186,4 +192,10 @@
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE p4z_sink_init  ***
+      !!
+      !! ** Purpose :   Initialization of sinking parameters
+      !!
+      !! ** Method  :   
+      !!
+      !! ** input   :   
       !!----------------------------------------------------------------------
       INTEGER :: jk
